/* adduser.c - Adds...erm...users. Graham J Lee 2004-06-15 */
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <pwd.h>
#include <sys/types.h>

int main(int argc, char **argv)
{
	int autoFlag=0,nameArg,helperStatus;
	uid_t curUID,startUID=500;
	gid_t userGID;
	char userStore[BUFSIZ],encPasswd[14],shell[BUFSIZ],homeDir[BUFSIZ],userGECOS[BUFSIZ],helperCmd[BUFSIZ],uidStr[6],gidStr[6];
	FILE *helperPipe;
	struct passwd pwEntry;

	strcpy(userStore,"");
	/*invocation: adduser [-a] [-i <type>] <username>*/
	if(!strcmp(argv[1],"-a"))
	{
		autoFlag=1;
		if(!strcmp(argv[2],"-i")) strncpy(userStore,argv[3],BUFSIZ);
	}
	else
	{
		if(!strcmp(argv[1],"-i")) strncpy(userStore,argv[2],BUFSIZ);
	}
	nameArg=*userStore?(autoFlag?4:2):(autoFlag?3:1);
	if((argc-nameArg)<1)
	{
		fprintf(stderr,"No username specified.  Aborting...\n");
		exit(EXIT_FAILURE);
	}
	/* choose a sensible default user information store */
	*userStore?0:strcpy(userStore,"netinfo");
	/* work out where to put the user and what values to give it */
	curUID=startUID;
	setpwent();
	if(getpwnam(argv[nameArg]))
	{
	    fprintf(stderr,"User %s already exists, ignoring...\n",argv[nameArg]);
	    /* I hope you're not squeamish... */
	    goto bailout;
	}
	setpwent();
	pwEntry.pw_name=argv[nameArg];
	if(autoFlag)
	{
	    while(getpwuid(++curUID));
	    pwEntry.pw_uid=curUID;
	    /* some reasonable(?) defaults 
	     * these could do with being settable
	     */
	    strcpy(encPasswd,"np");
	    pwEntry.pw_passwd=encPasswd;
	    strcpy(userGECOS,argv[nameArg]);
	    pwEntry.pw_gecos=userGECOS;
	    sprintf(homeDir,"/Users/%s",argv[nameArg]);
	    pwEntry.pw_dir=homeDir;
	    strcpy(shell,"/bin/csh");
	    pwEntry.pw_shell=shell;
	    pwEntry.pw_gid=100;
	}
	else
	{
	    while(1)
	    {
		printf("User ID for user %s: ",argv[nameArg]);
		scanf("%d",&curUID);
		if(getpwuid(curUID))
		{
		    fprintf(stderr,"That UID already exists, please choose another.\n");
		    setpwent();
		    break;
		}
	    }
	    strcpy(encPasswd,"np");
	    /* rather than fanny about with passwords, we'll let the admin
	     * run passwd once they've created the user
	     */
	    printf("Full name (GECOS entry): ");
	    fgets(userGECOS,BUFSIZ,stdin);
	    printf("Group ID: ");
	    scanf("%d",&userGID);
	    printf("Home directory: ");
	    fgets(homeDir,BUFSIZ,stdin);
	    printf("User's login shell: ");
	    fgets(shell,BUFSIZ,stdin);
	    pwEntry.pw_uid=curUID;
	    pwEntry.pw_gid=userGID;
	    strcpy(pwEntry.pw_name,argv[nameArg]);
	    strcpy(pwEntry.pw_passwd,encPasswd);
	    strcpy(pwEntry.pw_gecos,userGECOS);
	    strcpy(pwEntry.pw_dir,homeDir);
	    strcpy(pwEntry.pw_shell,shell);
	}
	/* call the necessary helper program */
	endpwent();
	sprintf(uidStr,"%d",pwEntry.pw_uid);
	sprintf(gidStr,"%d",pwEntry.pw_gid);
	/* sprintf(helperCmd,"/sbin/adduser.%s",userStore); */
	sprintf(helperCmd,"/sbin/adduser.%s",userStore);
	helperPipe=popen(helperCmd,"w");
	fputs(pwEntry.pw_name,helperPipe);
	fputc('\n',helperPipe);
	fputs(pwEntry.pw_passwd,helperPipe);
	fputc('\n',helperPipe);
	fputs(uidStr,helperPipe);
	fputc('\n',helperPipe);
	fputs(gidStr,helperPipe);
	fputc('\n',helperPipe);
	fputs(pwEntry.pw_gecos,helperPipe);
	fputc('\n',helperPipe);
	fputs(pwEntry.pw_dir,helperPipe);
	fputc('\n',helperPipe);
	fputs(pwEntry.pw_shell,helperPipe);
	fputc('\n',helperPipe);
	helperStatus=pclose(helperPipe);
	if(helperStatus) fprintf(stderr,"User %s may not have been created properly!\n",pwEntry.pw_name);		
 bailout:
	exit(EXIT_SUCCESS);
}
