/* adduser.master - helper app for adduser.
 * The new user is put in /etc/master.passwd. - Graham J Lee 2004-06-20
 */
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <pwd.h>
#include <sys/types.h>
#include <errno.h>
#include <sys/timeb.h>

int main(int argc,char **argv)
{
    char userName[BUFSIZ],encPW[14],userGECOS[BUFSIZ],userDir[BUFSIZ],userShell[BUFSIZ],tempName[12],cpCmd[BUFSIZ];
    struct timeb userChPass;
    FILE *tempFile;
    uid_t userUID;
    gid_t userGID;
    extern int errno;

    fgets(userName,BUFSIZ,stdin);
    fgets(encPW,14,stdin);
    scanf("%d",&userUID);
    scanf("%d",&userGID);
    fgets(userGECOS,BUFSIZ,stdin);
    fgets(userDir,BUFSIZ,stdin);
    fgets(userShell,BUFSIZ,stdin);

    ftime(&userChPass);
    /* Get rid of those pesky newlines */
    userName[strlen(userName)-1]='\0';
    encPW[strlen(encPW)-1]='\0';
    userGECOS[strlen(userGECOS)-1]='\0';
    userDir[strlen(userDir)-1]='\0';
    userShell[strlen(userShell)-1]='\0';


    strcpy(tempName,"/tmp/aumasXXXXXX");
    mkstemp(tempName);
    /* Yeah, so there's a race condition.  In practice you'd need to attach a
     * debugger to the process to be able to tickle it.
     */
    sprintf(cpCmd,"cp /etc/master.passwd %s",tempName);
    if(system(cpCmd)==-1)
    {
	fprintf(stderr,"Unable to copy master password file: %s.\nAdduser aborted - user not added.\n",strerror(errno));
	exit(EXIT_FAILURE);
    }

    /* Assume all checking is done in adduser and we can just go ahead */
    errno=0;
    if(!(tempFile=fopen(tempName,"a")))
    {
	fprintf(stderr,"Unable to open temporary file: %s.\nAdduser aborted - user has not been added.\n",strerror(errno));
	exit(EXIT_FAILURE);
    }

    fprintf(tempFile,"%s:%s:%d:%d::%d:0:%s:%s:%s\n",userName,encPW,userUID,userGID,userChPass.time,userGECOS,userDir,userShell);
    fclose(tempFile);
    /* Danger Will Robinson! */
    if(unlink("/etc/master.passwd")==-1)
    {
	fprintf(stderr,"Unable to unlink password file: %s.\nAdduser aborted!\n",strerror(errno));
	exit(EXIT_FAILURE);
    }
    if(link(tempName,"/etc/master.passwd")==-1)
    {
 	fprintf(stderr,"Unable to link master.passwd: %s.\nYOU HAVE NO MASTER.PASSWD!!!!\n",strerror(errno));
	exit(EXIT_FAILURE);
    }
    if(unlink(tempName)==-1)
    {
	fprintf(stderr,"Unable to unlink temporary file %s: %s.\nThis file is copy of your /etc/master.passwd: UNLINK IT!!!!\n",tempName,strerror(errno));
	exit(EXIT_FAILURE);
    }
    exit(EXIT_SUCCESS);
}
