/* adduser.netinfo - helper app for adduser.
 * The new user is added to Netinfo in . /users but will carry on up to / if it
 * can't write it any earlier.
 * Graham J Lee 2004-06-28
 */

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <netinfo/ni.h>
#include <sys/types.h>
#include <pwd.h>
#include <string.h>

/* Some functions that are used in manipulating Netinfo.  This is based on
 * the Darwin netinfo_passwd, which I ported to NeXTSTEP
 */
char *getNiDomain(void *niHandle);
char *getNiParent(char *niDomain);
char *getNiProp(char *niProp,char *niName,char *startNiDomain,void **niHandle,ni_id **niId);
int getNiDirectory(char *niName,char *startNiDomain,void **niHandle,ni_id **niId);


int main(int argc,char **argv)
{
	char userName[BUFSIZ],userUID[BUFSIZ],userGID[BUFSIZ],userGECOS[BUFSIZ],encPW[14],userDir[BUFSIZ],userShell[BUFSIZ],testString[BUFSIZ];
	uid_t uid;
	gid_t gid;

	/* NetInfo variable declarations */
	ni_id *niId;
	ni_index niIndex;
	ni_proplist *niPropList;
	ni_status niStatus;
	void *niHandle;

	/* Obtain the user's information */
	fgets(userName,BUFSIZ,stdin);
	fgets(encPW,14,stdin);
	scanf("%d",&uid);
	scanf("%d",&gid);
	fgets(userGECOS,BUFSIZ,stdin);
	fgets(userDir,BUFSIZ,stdin);
	fgets(userShell,BUFSIZ,stdin);

	sprintf(userUID,"%d",uid);
	sprintf(userGID,"%d",gid);

	/* Just in case adduser did the wrong thing, we'll search for our user
	 * in Netinfo.  Hopefully this will never exit.
	 */
	niId=(ni_id *)malloc(sizeof(ni_id));
	sprintf(testString,"uid=%s",userUID);
	if(getNiProp("name",testString,".",&niHandle,&niId))
	{
		fprintf(stderr,"A user with this UID already exists.\nUser creation has been aborted!\n");
		exit(EXIT_FAILURE);
	}
	strncpy(testString,userName,BUFSIZ);
	if(getNiProp("uid",testString,".",&niHandle,&niId))
	{
		fprintf(stderr,"A user with this username already exists.\nUser creation has been aborted!\n");
		exit(EXIT_FAILURE);
	}

	/* Good, so our user doesn't exist.  We can now add them into Netinfo.
	 */
	niPropList=(ni_proplist *)malloc(sizeof(ni_proplist));
	NI_INIT(niPropList);
	ni_setuser(niHandle,"root");	