/* adduser.passwd - helper app for adduser.
 * The new user is put in /etc/passwd. - Graham J Lee 2004-06-20
 */
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <pwd.h>
#include <sys/types.h>
#include <errno.h>

int main(int argc,char **argv)
{
    char userName[BUFSIZ],encPW[14],userGECOS[BUFSIZ],userDir[BUFSIZ],userShell[BUFSIZ],tempName[12];
    struct passwd *tempEntry,userEntry;
    FILE *tempFile;
    uid_t userUID;
    gid_t userGID;
    extern int errno;

    fgets(userName,BUFSIZ,stdin);
    fgets(encPW,14,stdin);
    scanf("%d",&userUID);
    scanf("%d",&userGID);
    fgets(userGECOS,BUFSIZ,stdin);
    fgets(userDir,BUFSIZ,stdin);
    fgets(userShell,BUFSIZ,stdin);

    /* Get rid of those pesky newlines */
    userName[strlen(userName)-1]='\0';
    encPW[strlen(encPW)-1]='\0';
    userGECOS[strlen(userGECOS)-1]='\0';
    userDir[strlen(userDir)-1]='\0';
    userShell[strlen(userShell)-1]='\0';

    userEntry.pw_name=userName;
    userEntry.pw_passwd=encPW;
    userEntry.pw_uid=userUID;
    userEntry.pw_gid=userGID;
    userEntry.pw_gecos=userGECOS;
    userEntry.pw_dir=userDir;
    userEntry.pw_shell=userShell;

    strcpy(tempName,"/tmp/aupwdXXXXXX");
    mkstemp(tempName);
    /* Yeah, so there's a race condition.  In practice you'd need to attach a
     * debugger to the adduser.passwd process to be able to tickle it.
     */

    /* Assume all checking is done in adduser and we can just go ahead */
    errno=0;
    if(!(tempFile=fopen(tempName,"w")))
    {
	fprintf(stderr,"Unable to create temporary file: %s.\nAdduser aborted!\n",strerror(errno));
	exit(EXIT_FAILURE);
    }
    setpwent();
    while((tempEntry=getpwent())) putpwent(tempEntry,tempFile);
    endpwent();
    
    putpwent(&userEntry,tempFile);

    /* Danger Will Robinson! */
    if(unlink("/etc/passwd")==-1)
    {
	fprintf(stderr,"Unable to unlink password file: %s.\nAdduser aborted!\n",strerror(errno));
	exit(EXIT_FAILURE);
    }
    if(link(tempName,"/etc/passwd")==-1)
    {
	fprintf(stderr,"Unable to link password file: %s.\nAdduser aborted - NOTE YOU HAVE NO /etc/passwd FILE!!!!!!\n",strerror(errno));
	exit(EXIT_FAILURE);
    }
    if(unlink(tempName)==-1)
    {
	fprintf(stderr,"Unable to unlink temporary file %s: %s.\nThis file is a hard link to /etc/passwd: UNLINK IT!!!!\n",tempName,strerror(errno));
	exit(EXIT_FAILURE);
    }
    fclose(tempFile);
    exit(EXIT_SUCCESS);
}
